;##################################################################
; MP3Player
;##################################################################

STRINGS UNICODE
#DEFINE UNICODE

#include DShow.h

/*
#define DEBUGEXE "C:\Programming\RadASM3\GoAsm\dbg\DbgWin.exe"
#define PRESERVEXMMREGS
#define DBG64LIB "C:\Programming\RadASM3\GoAsm\dbg\Debug64.lib"
#define DBG32LIB "C:\Programming\RadASM3\GoAsm\dbg\Debug32.lib"
#IF X64
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug64.a"
#ELSE
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug32.a"
#ENDIF
*/

#IF X64
	S=8
#ELSE
	S=4
#ENDIF

// Maximum progress bar range
// 1000 seems to be the most useful range
PBRANGEMAX = 1000

DATA SECTION
	hInstance	HANDLE ?
	hSeekBar	HANDLE ?
	hVolBar		HANDLE ?

	pigb		PTR NULL
	pimc		PTR NULL
	pimex		PTR NULL
	piba		PTR NULL
	pims		PTR NULL
	pivw		PTR NULL
	ready		BOOL FALSE
	duration	LONGLONG 0

	IID_IGraphBuilder GUID GUID_IID_IGraphBuilder
	IID_IMediaControl GUID GUID_IID_IMediaControl
	IID_IMediaEventEx GUID GUID_IID_IMediaEventEx
	IID_IBasicAudio GUID GUID_IID_IBasicAudio
	IID_IMediaSeeking GUID GUID_IID_IMediaSeeking
	IID_IVideoWindow GUID GUID_IID_IVideoWindow
	CLSID_FilterGraph GUID GUID_CLSID_FilterGraph
	TIME_FORMAT_MEDIA_TIME GUID GUID_TIME_FORMAT_MEDIA_TIME

	// Test movie is found at http://www.bigbuckbunny.org/

	szFilterStr			DUS "Media files",0,"*.avi;*.mp3;*.mp4;*.mkv;*.ogg;*.divx;*.xvid;*.wmv;*.wma;*.wm;*.wmx;*.wav;*.mpg",0,"All files",0,"*.*",0,0
	szDefExt			DUS "avi",0
	szOpenCaption		DUS "Open a media file",0
	ofrFilePath			DUS MAX_PATH DUP (?)

	evcode DD 0

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke CoInitialize,NULL
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke CoUninitialize
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_COMMAND
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_CLOSE
			invoke GetMediaFile,[hwnd]
			test eax,eax
			jz >>.EXIT
			invoke Load,[hwnd],offset ofrFilePath
			invoke SetVolume,0
			invoke Play
			invoke GetDlgItem,[hwnd],1002
			mov [hSeekBar],eax
			invoke SendMessage,[hSeekBar],PBM_SETRANGE32,0,PBRANGEMAX
			invoke SendMessage,[hSeekBar],PBM_SETSTEP,1,0
			invoke SetTimer,[hSeekBar],99,1000,offset SetProgress
			invoke SetWindowSubclass,[hSeekBar],offset SeekBarSubClass,1,0

			invoke GetDlgItem,[hwnd],1003
			mov [hVolBar],eax
			// Volume is always -10000 to 0 so set our range to that fixed value
			invoke SendMessage,[hVolBar],PBM_SETRANGE32,0,10000
			invoke SendMessage,[hVolBar],PBM_SETSTEP,1,0
			// For the test always start the volume at MAX so set the progress bar
			invoke SendMessage,[hVolBar],PBM_SETPOS,10000,0
			invoke SetWindowSubclass,[hVolBar],offset VolumeBarSubClass,2,0

		;	invoke WaitForCompletion,10000,offset evcode
			jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		call Cleanup
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

SeekBarSubClass FRAME hwnd,uMsg, wParam, lParam, uIdSubclass, dwRefData
	LOCAL pt:POINT
	LOCAL rct:RECT
	LOCAL pbHitTest:D
	LOCAL rangemax:D
	LOCAL newpos:Q

	// Some of the parameters that are calculated here
	// can be done at load time. For now I calculate them
	// on the fly.

	cmp D[uMsg],WM_LBUTTONDOWN
	jne >>.DEFPROC
		// Calculate the position inside the seek bar
		// First we need a hit test
		invoke GetCursorPos,offset pt
		invoke ScreenToClient,[hwnd],offset pt
		// Next we need the width of the seek bar - this can be done at load time
		invoke GetClientRect,[hwnd],offset rct
		// Calculate the postion
		mov eax,[pt.x]
		mov ecx,PBRANGEMAX
		mul ecx
		xor edx,edx
		div D[rct.right]
		mov [pbHitTest],eax
		// EAX contains the hit test result, the value is between 0 and PBRANGEMAX (the range of the progress bar)
		// Now we need to translate that into an absolute time based on [duration]

		// Find out how many ticks to 1/PBRANGEMAX of the file - this can be done at load time
		mov D[rangemax],PBRANGEMAX
		fild    D[rangemax]
		fild    Q[duration]
		fdivrp  st1, st0

		// Ok now we calculate the time to set using our hit test
		fild	D[pbHitTest]
		fmulp  st1, st0
		fistp	Q[newpos]

		// Set the playback to that position
		invoke SetPositions,offset newpos,offset duration,TRUE

	.DEFPROC
	invoke DefSubclassProc, [hwnd], [uMsg], [wParam], [lParam]
	ret
endf

VolumeBarSubClass FRAME hwnd,uMsg, wParam, lParam, uIdSubclass, dwRefData
	LOCAL pt:POINT
	LOCAL rct:RECT
	LOCAL newvol:D

	// Set the volume
	// Based on 10*log2(x)

	cmp D[uMsg],WM_LBUTTONDOWN
	jne >>.DEFPROC
		// Calculate the position inside the volume bar
		// First we need a hit test
		invoke GetCursorPos,offset pt
		invoke ScreenToClient,[hwnd],offset pt
		invoke GetClientRect,[hwnd],offset rct
		// Calculate the postion
		mov eax,[pt.x]
		mov ecx,10000
		mul ecx
		xor edx,edx
		div D[rct.right]

		// EAX contains the hit test result, the value is between 0 and 10000 (the range of the progress bar)
		push eax

		// A quick hack to give us a logarithmic scale
		// Calculate the inverse volume
		mov [newvol],eax
		fld Q[Multiplier]
		fild D[newvol]
		FYL2X
		fistp D[newvol]

		// invert the result
		mov edx,10000
		sub [newvol],edx

		// Set the volume
		invoke SetVolume,[newvol]
		// Reposition the volume bar
		pop eax
		invoke SendMessage,[hwnd],PBM_SETPOS,eax,0

	.DEFPROC
	invoke DefSubclassProc, [hwnd], [uMsg], [wParam], [lParam]
	ret

	Multiplier:	DOUBLE 752.57500515316827920992790535456
endf

GetMediaFile FRAME hDlg
	LOCAL ofn				:OPENFILENAME
	LOCAL ofrFileTitle[64]	:%CHAR

	mov D[ofn.lStructSize],SIZEOF OPENFILENAME
	mov eax,[hDlg]
	mov [ofn.hwndOwner],eax
	mov eax,[hInstance]
	mov D[ofn.hInstance],NULL
	mov [ofn.lpstrFilter],OFFSET szFilterStr
	mov D[ofn.lpstrCustomFilter],NULL
	mov D[ofn.nMaxCustFilter],NULL
	mov D[ofn.nFilterIndex],1
	mov eax,OFFSET ofrFilePath
	mov D[eax],0
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov D[ofn.lpstrFileTitle],NULL
	mov D[ofn.nMaxFileTitle],NULL
	mov D[ofn.lpstrInitialDir],NULL
	mov [ofn.lpstrTitle],OFFSET szOpenCaption
	mov D[ofn.Flags],OFN_FILEMUSTEXIST + OFN_NONETWORKBUTTON + OFN_EXPLORER + OFN_HIDEREADONLY
	mov D[ofn.lpfnHook],NULL
	mov D[ofn.lpTemplateName],NULL
	mov [ofn.lpstrDefExt],OFFSET szDefExt
	mov D[ofn.lCustData],NULL

	invoke GetOpenFileName,ADDR ofn
	ret
ENDF

Cleanup:
	cmp S[pimc],0
	je >
		CoInvoke(pimc,IMediaControl.Stop)
	:
	cmp S[pigb],0
	je >
		CoInvoke(pigb,IGraphBuilder.Release)
		mov S[pigb],NULL
	:
	cmp S[pimc],0
	je >
		CoInvoke(pimc,IMediaControl.Release)
		mov S[pimc],NULL
	:
	cmp S[pimex],0
	je >
		CoInvoke(pimex,IMediaEventEx.Release)
		mov S[pimex],NULL
	:
	cmp S[piba],0
	je >
		CoInvoke(piba,IBasicAudio.Release)
		mov S[piba],NULL
	:
	cmp S[pims],0
	je >
		CoInvoke(pims,IMediaSeeking.Release)
		mov S[pims],NULL
	:
	cmp S[pivw],0
	je >
		CoInvoke(pivw,IVideoWindow.Release)
		mov S[pivw],NULL
	:
	mov D[ready],FALSE
	RET

Load FRAME hWin,szFile
	LOCAL LocResult:D
	LOCAL WinRect:RECT

	call Cleanup

	mov D[ready],FALSE
	invoke CoCreateInstance,offset CLSID_FilterGraph,NULL,CLSCTX_INPROC_SERVER,offset IID_IGraphBuilder,offset pigb
	test eax,eax

	jnz >>.EXIT
		xor eax,eax
		mov [LocResult],eax
		CoInvoke(pigb,IGraphBuilder.IUnknown.QueryInterface,offset IID_IVideoWindow,offset pivw)
		mov [LocResult],eax
		CoInvoke(pigb,IGraphBuilder.IUnknown.QueryInterface,offset IID_IMediaControl,offset pimc)
		or [LocResult],eax
		CoInvoke(pigb,IGraphBuilder.IUnknown.QueryInterface,offset IID_IMediaEventEx,offset pimex)
		or [LocResult],eax
		CoInvoke(pigb,IGraphBuilder.IUnknown.QueryInterface,offset IID_IBasicAudio,offset piba)
		or [LocResult],eax
		CoInvoke(pigb,IGraphBuilder.IUnknown.QueryInterface,offset IID_IMediaSeeking,offset pims)

		or [LocResult],eax
		cmp D[LocResult],0
		jne >>.EXIT

		CoInvoke(pigb,IGraphBuilder.RenderFile,[szFile],NULL)
		test eax,eax
		jnz >>.EXIT
			mov D[ready],TRUE
			cmp S[pims],0
			je >>.EXIT
				CoInvoke(pims,IMediaSeeking.SetTimeFormat,offset TIME_FORMAT_MEDIA_TIME)
				CoInvoke(pims,IMediaSeeking.GetDuration,offset duration)

				// Set the parent window
				// If this is not a video file No Such Interface is returned (0x80004002)
				CoInvoke(pivw,IVideoWindow.put_Owner,[hWin])
				test eax,eax
				jnz >>.NOVIDEO
				CoInvoke(pivw,IVideoWindow.put_WindowStyle,WS_CHILD | WS_CLIPCHILDREN | WS_CLIPSIBLINGS)
				invoke GetClientRect,[hWin],offset WinRect
				sub D[WinRect.bottom],35
				CoInvoke(pivw,IVideoWindow.SetWindowPosition,[WinRect.left], [WinRect.top], [WinRect.right], [WinRect.bottom])
				CoInvoke(pivw,IVideoWindow.put_MessageDrain,[hWin])

	.EXIT
	mov eax,[ready]
	ret

	.NOVIDEO
	CoInvoke(pivw,IVideoWindow.Release)
	mov S[pivw],NULL
	mov eax,[ready]
	ret

ENDF

Play:
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[pimc],0
	je >>.EXIT
		CoInvoke(pimc,IMediaControl.Run)
		ret
	.EXIT
	mov eax,-1
	ret

Pause:
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[pimc],0
	je >>.EXIT
		CoInvoke(pimc,IMediaControl.Pause)
		ret
	.EXIT
	mov eax,-1
	ret

Stop:
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[pimc],0
	je >>.EXIT
		CoInvoke(pimc,IMediaControl.Stop)
		ret
    .EXIT
	mov eax,-1
	ret

WaitForCompletion FRAME msTimeout, pEvCode
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[pimex],0
	je >>.EXIT
		CoInvoke(pimex,IMediaEventEx.WaitForCompletion,[msTimeout],[pEvCode])
		cmp eax,0
		jne >.EXIT
		mov eax,1
		ret
	.EXIT
	mov eax,0
	ret
ENDF

SetVolume FRAME vol
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[piba],0
	je >>.EXIT
		CoInvoke(piba,IBasicAudio.put_Volume,[vol])
		ret
    .EXIT
	mov eax,-1
	ret
ENDF

GetVolume FRAME pvol
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[piba],0
	je >>.EXIT
		CoInvoke(piba,IBasicAudio.get_Volume,[pvol])
		ret
    .EXIT
	mov eax,-1
	ret
ENDF

GetCurrentPosition FRAME pInt64curpos
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[pims],0
	je >>.EXIT
		mov eax,[pInt64curpos]
		mov D[eax],-1
		mov D[eax+4],-1
		CoInvoke(pims,IMediaSeeking.GetCurrentPosition,[pInt64curpos])
		ret
    .EXIT
	mov eax,-1
	ret
ENDF

// timer proc called every 1 sec
SetProgress FRAME hProg, uMsg, id, dwTime
	LOCAL curPos:Q
	LOCAL stopPos:Q
	LOCAL pos:Q
	LOCAL rangemax:D

	// range of progress control is set to 1000

	mov D[rangemax],PBRANGEMAX
	CoInvoke(pims,IMediaSeeking.GetPositions,offset curPos,offset stopPos)
	
	fild    Q[stopPos]
	fild    Q[curPos]
	fdivrp  st1, st0
	fild D[rangemax]
	fmulp
	fistp   Q[pos]
	invoke SendMessage,[hProg],PBM_SETPOS,[pos],0
	ret
endf

SetPositions FRAME pINT64Current, pINT64Stop, bAbsolutePositioning
	LOCAL Posflags:D

	mov D[Posflags],0
	cmp D[ready],FALSE
	je >>.EXIT
	cmp S[pims],0
	je >>.EXIT
		cmp D[bAbsolutePositioning],0
		je >
			mov D[Posflags], AM_SEEKING_AbsolutePositioning | AM_SEEKING_SeekToKeyFrame
			jmp >>.SETPOS
        :
			mov D[Posflags], AM_SEEKING_RelativePositioning | AM_SEEKING_SeekToKeyFrame
		.SETPOS
		CoInvoke(pims,IMediaSeeking.SetPositions,[pINT64Current], [Posflags], [pINT64Stop], [Posflags])
		ret
	.EXIT
	mov eax,-1
	ret
ENDF
